Index: /palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3967)
+++ /palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3968)
@@ -1390,55 +1576,54 @@
                 j = surf_def_h(0)%j(m)
 
-                IF ( emis_distribution(1,j,i,ispec) > 0.0_wp )  THEN
-
-                   !
-                   !-- PMs
-                   IF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM1"  &
-                        .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM25"  &
-                          .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM10" )  THEN
+                IF  ( emis_distribution(1,j,i,ispec) > 0.0_wp )  THEN
+
+!
+!-- PMs
+                   IF  ( TRIM(spc_names(match_spec_model(ispec))) == "PM1"     .OR.    &
+                         TRIM(spc_names(match_spec_model(ispec))) == "PM25"    .OR.    &
+                         TRIM(spc_names(match_spec_model(ispec))) == "PM10" )  THEN
                 
-                      !
-                      !--            kg/(m^2*s) *kg/m^3                         kg/(m^2*s)                 
-                      surf_def_h(0)%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec)*  &
-                                                                        rho_air(nzb)                           !< in kg/m^3  
- 
+                      surf_def_h(0)%cssws(match_spec_model(ispec),m) =         &     ! kg/m2/s * kg/m3
+                               emis_distribution(1,j,i,ispec)*                 &     ! kg/m2/s
+                               rho_air(nzb)                                          ! kg/m^3  
  
                    ELSE
 
-                      !
-                      !-- VOCs
-                      IF ( len_index_voc > 0 .AND. emt_att%species_name(match_spec_input(ispec)) == "VOC" )  THEN
-                         !
-                         !--           (ppm/s) * m * kg/m^3                        mole/(m^2/s)   
-                         surf_def_h(0)%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *  &
-                                                                           conv_to_ratio(nzb,j,i) *         &  !< in m^3/mole
-                                                                            ratio2ppm *                     &  !< in ppm
-                                                                             rho_air(nzb)                      !< in kg/m^3  
-
-
-                      !
-                      !-- Other species
+!
+!-- VOCs
+                      IF  ( len_index_voc > 0                                           .AND.      &
+                            emt_att%species_name(match_spec_input(ispec)) == "VOC" )  THEN
+
+                         surf_def_h(0)%cssws(match_spec_model(ispec),m) =      &  ! ppm/s * m * kg/m3
+                               emis_distribution(1,j,i,ispec) *                &  ! mole/m2/s
+                               conv_to_ratio(nzb,j,i) *                        &  ! m^3/mole
+                               ratio2ppm *                                     &  ! ppm
+                               rho_air(nzb)                                       ! kg/m^3  
+
+
+!
+!-- Other species
+
                       ELSE
 
-                         !
-                         !--           (ppm/s) * m  * kg/m^3                    kg/(m^2/s)
-                         surf_def_h(0)%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *  &       
-                                                                           ( 1.0_wp / emt_att%xm(ispec) ) * &  !< in mole/kg 
-                                                                             conv_to_ratio(nzb,j,i) *       &  !< in m^3/mole  
-                                                                              ratio2ppm *                   &  !< in ppm 
-                                                                               rho_air(nzb)                    !< in  kg/m^3  
+                         surf_def_h(0)%cssws(match_spec_model(ispec),m) =      &   ! ppm/s * m * kg/m3
+                               emis_distribution(1,j,i,ispec) *                &   ! kg/m2/s
+                               ( 1.0_wp / emt_att%xm(ispec) ) *                &   ! mole/kg 
+                               conv_to_ratio(nzb,j,i) *                        &   ! m^3/mole  
+                               ratio2ppm *                                     &   ! ppm 
+                               rho_air(nzb)                                        !  kg/m^3  
   
-
-                      ENDIF
-
-                   ENDIF
-
-                ENDIF
-
-             ENDDO
+                      ENDIF  ! VOC
+
+                   ENDIF  ! PM
+
+                ENDIF  ! emis_distribution > 0
+
+             ENDDO  ! m
          
 !
-!--          LSM surfaces
-             DO m = 1, surf_lsm_h%ns
+!-- LSM surfaces
+
+             DO  m = 1, surf_lsm_h%ns
 
                 i = surf_lsm_h%i(m)
@@ -1446,51 +1631,54 @@
                 k = surf_lsm_h%k(m)
 
-                IF ( emis_distribution(1,j,i,ispec) > 0.0_wp )  THEN
-
-                   !
-                   !-- PMs
-                   IF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM1"  &
-                        .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM25"  &
-                          .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM10" )  THEN
-   
-                      !
-                      !--         kg/(m^2*s) * kg/m^3                           kg/(m^2*s)            
-                      surf_lsm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *  &
-                                                                     rho_air(k)                                !< in kg/m^3
+                IF  ( emis_distribution(1,j,i,ispec) > 0.0_wp )  THEN
+
+!
+!-- PMs
+                   IF  ( TRIM(spc_names(match_spec_model(ispec))) == "PM1"     .OR.    &
+                         TRIM(spc_names(match_spec_model(ispec))) == "PM25"    .OR.    &
+                         TRIM(spc_names(match_spec_model(ispec))) == "PM10" )  THEN
+
+                      surf_lsm_h%cssws(match_spec_model(ispec),m) =            &    ! kg/m2/s * kg/m3
+                               emis_distribution(1,j,i,ispec) *                &    ! kg/m2/s
+                               rho_air(k)                                           ! kg/m^3
  
                    ELSE
 
-                      !
-                      !-- VOCs
-                      IF ( len_index_voc > 0 .AND. emt_att%species_name(match_spec_input(ispec)) == "VOC" )  THEN
-                         !
-                         !--          (ppm/s) * m * kg/m^3                        mole/(m^2/s)   
-                         surf_lsm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *  &     
-                                                                        conv_to_ratio(k,j,i) *           &     !< in m^3/mole
-                                                                         ratio2ppm *                     &     !< in ppm
-                                                                          rho_air(k)                           !< in kg/m^3  
-
-                      !
-                      !-- Other species
+!
+!-- VOCs
+
+                      IF  ( len_index_voc > 0                                           .AND.      &
+                            emt_att%species_name(match_spec_input(ispec)) == "VOC" )  THEN
+
+                         surf_lsm_h%cssws(match_spec_model(ispec),m) =         &   ! ppm/s * m * kg/m3
+                               emis_distribution(1,j,i,ispec) *                &   ! mole/m2/s  
+                               conv_to_ratio(k,j,i) *                          &   ! m^3/mole
+                               ratio2ppm *                                     &   ! ppm
+                               rho_air(k)                                          ! kg/m^3  
+
+!
+!-- Other species
+
                       ELSE
-                         !
-                         !--           (ppm/s) * m  * kg/m^3                    kg/(m^2/s)
-                         surf_lsm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *  & 
-                                                                        ( 1.0_wp / emt_att%xm(ispec) ) * &     !< in mole/kg
-                                                                         conv_to_ratio(k,j,i) *          &     !< in m^3/mole
-                                                                          ratio2ppm *                    &     !< in ppm
-                                                                           rho_air(k)                          !< in kg/m^3     
+
+                         surf_lsm_h%cssws(match_spec_model(ispec),m) =         &   ! ppm/s * m * kg/m3
+                               emis_distribution(1,j,i,ispec) *                &   ! kg/m2/s
+                               ( 1.0_wp / emt_att%xm(ispec) ) *                &   ! mole/kg
+                               conv_to_ratio(k,j,i) *                          &   ! m^3/mole
+                               ratio2ppm *                                     &   ! ppm
+                               rho_air(k)                                          ! kg/m^3     
                                                    
-                      ENDIF
-
-                   ENDIF
-
-                ENDIF
-
-             ENDDO
-
-!
-!--          USM surfaces
-             DO m = 1, surf_usm_h%ns
+                      ENDIF  ! VOC
+
+                   ENDIF  ! PM
+
+                ENDIF  ! emis_distribution
+
+             ENDDO  ! m
+
+!
+!-- USM surfaces
+
+             DO  m = 1, surf_usm_h%ns
 
                 i = surf_usm_h%i(m)
@@ -1498,50 +1686,48 @@
                 k = surf_usm_h%k(m)
 
-                IF ( emis_distribution(1,j,i,ispec) > 0.0_wp )  THEN
-
-                   !
-                   !-- PMs
-                   IF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM1" &
-                        .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM25"  &
-                          .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM10" )  THEN
+                IF  ( emis_distribution(1,j,i,ispec) > 0.0_wp )  THEN
+
+!
+!-- PMs
+                   IF  ( TRIM(spc_names(match_spec_model(ispec))) == "PM1"     .OR.    &
+                         TRIM(spc_names(match_spec_model(ispec))) == "PM25"    .OR.    &
+                         TRIM(spc_names(match_spec_model(ispec))) == "PM10" )  THEN
                    
-                      !
-                      !--          kg/(m^2*s) *kg/m^3                             kg/(m^2*s)                     
-                      surf_usm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec)*  & 
-                                                                     rho_air(k)                                !< in kg/m^3
-
- 
+                      surf_usm_h%cssws(match_spec_model(ispec),m) =            &    ! kg/m2/s * kg/m3
+                               emis_distribution(1,j,i,ispec)*                 &    ! kg/m2/s
+                               rho_air(k)                                           ! kg/m^3
+
                    ELSE
                       
-                      !
-                      !-- VOCs
-                      IF ( len_index_voc > 0 .AND. emt_att%species_name(match_spec_input(ispec)) == "VOC" ) THEN
-                         !
-                         !--          (ppm/s) * m * kg/m^3                        mole/(m^2/s)   
-                         surf_usm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *  &
-                                                                        conv_to_ratio(k,j,i) *           &     !< in m^3/mole
-                                                                         ratio2ppm *                     &     !< in ppm
-                                                                          rho_air(k)                           !< in kg/m^3   
-
-                      !
-                      !-- Other species
+!
+!-- VOCs
+                      IF  ( len_index_voc > 0                                           .AND.      &
+                            emt_att%species_name(match_spec_input(ispec)) == "VOC" )  THEN
+
+                         surf_usm_h%cssws(match_spec_model(ispec),m) =         &   ! ppm/s * m * kg/m3
+                               emis_distribution(1,j,i,ispec) *                &   ! m2/s
+                               conv_to_ratio(k,j,i) *                          &   ! m^3/mole
+                               ratio2ppm *                                     &   ! ppm
+                               rho_air(k)                                          ! kg/m^3   
+
+!
+!-- Other species
                       ELSE
 
-                         !
-                         !--          (ppm/s) * m * kg/m^3                        kg/(m^2/s)                      
-                         surf_usm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *  &   
-                                                                        ( 1.0_wp / emt_att%xm(ispec) ) * &     !< in mole/kg
-                                                                         conv_to_ratio(k,j,i) *          &     !< in m^3/mole
-                                                                          ratio2ppm*                     &     !< in ppm
-                                                                           rho_air(k)                          !< in kg/m^3   
-
-
-                      ENDIF
-
-                   ENDIF
-
-                ENDIF
- 
-             ENDDO
+                         surf_usm_h%cssws(match_spec_model(ispec),m) =         &   ! ppm/s * m * kg/m3
+                               emis_distribution(1,j,i,ispec) *                &   ! kg/m2/s
+                               ( 1.0_wp / emt_att%xm(ispec) ) *                &   ! mole/kg
+                               conv_to_ratio(k,j,i) *                          &   ! m^3/mole
+                               ratio2ppm*                                      &   ! ppm
+                               rho_air(k)                                          ! kg/m^3   
+
+
+                      ENDIF  ! VOC
+
+                   ENDIF  ! PM
+
+                ENDIF  ! emis_distribution
+ 
+             ENDDO  ! m
 
           ENDDO
@@ -1549,7 +1735,8 @@
        ENDIF
 
-       !
-       !-- Deallocate time_factor in case of DEFAULT mode) 
-       IF ( ALLOCATED ( time_factor ) ) DEALLOCATE( time_factor )
+!
+!-- Deallocate time_factor in case of DEFAULT mode) 
+
+       IF  ( ALLOCATED (time_factor) )  DEALLOCATE (time_factor)
 
    ENDIF
Index: /palm/trunk/SOURCE/chem_modules.f90
===================================================================
--- /palm/trunk/SOURCE/chem_modules.f90	(revision 3967)
+++ /palm/trunk/SOURCE/chem_modules.f90	(revision 3968)
@@ -27,4 +27,13 @@
 ! -----------------
 ! $Id$
+! - introduced namelist item chem_modules@emiss_lod as future
+! - replacement to chem_modules@mode_emis.  Currently keeping both
+!   for backward compatibility.  chem_modules@mode_emis will be
+!   depreciated upon migration of all dependent modules (e.g., salsa)
+!   to chem_modules@emiss_lod
+!
+! (ecc) 20190513 replaced nspec_out with n_matched_vars
+! 
+! 3877 2019-04-08 19:09:16Z knoop
 ! Formatting, clean-up, clarified/corrected comments
 ! 
@@ -102,4 +111,6 @@
     INTEGER(iwp) ::  cs_pr_count                           = 0      !< counter for chemical species profiles
     INTEGER(iwp) ::  cs_vertical_gradient_level_ind(99,10) = -9999  !< grid index values of cs_vertical_gradient_level
+    INTEGER(iwp) ::  emiss_lod                             = -1     !< namelist parameter: chem emission LOD (same as mode_emis)
+                                                                    !< -1 = unassigned, 0 = parameterized, 1 = default, 2 = pre-processed
     INTEGER(iwp) ::  ibc_cs_b                                       !< integer flag for bc_cs_b
     INTEGER(iwp) ::  ibc_cs_t                                       !< integer flag for bc_cs_t
@@ -107,5 +118,5 @@
     INTEGER(iwp) ::  max_pr_cs                             = 0      !< 
     INTEGER(iwp) ::  max_street_id                         = 0      !< namelist parameter: upper bound of main street IDs (OpenStreetMaps) for PARAMETERIZED mode      
-    INTEGER(iwp) ::  nspec_out                                      !< output of routine chem_emis_matching with.....???
+    INTEGER(iwp) ::  n_matched_vars                                 !< number of matched emissions variables
     INTEGER(iwp) ::  side_street_id                        = 0      !< namelist parameter: lower bound of side street IDs (OpenStreetMaps) for PARAMETERIZED mode
 
Index: /palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3967)
+++ /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3968)
@@ -27,4 +27,13 @@
 ! -----------------
 ! $Id$
+! - added "emiss_lod" which serves the same function as "mode_emis"
+!   both will be synchronized with emiss_lod having pirority over
+!   mode_emis (see informational messages)
+! - modified existing error message and introduced new informational messages
+!    - CM0436 - now also applies to invalid LOD settings
+!    - CM0463 - emiss_lod take precedence in case of conflict with mod_emis
+!    - CM0464 - emiss_lod valued assigned based on mode_emis if undefined
+! 
+! 3930 2019-04-24 14:57:18Z forkel
 ! Changed chem_non_transport_physics to chem_non_advective_processes
 ! 
@@ -1682,11 +1691,14 @@
 !
 !-- Emission mode info
-    IF ( mode_emis == "DEFAULT" )  THEN 
-       WRITE( io, 5 ) 
-    ELSEIF ( mode_emis == "PARAMETERIZED" )  THEN 
-       WRITE( io, 6 )
-    ELSEIF ( mode_emis == "PRE-PROCESSED" )  THEN 
-       WRITE( io, 7 )
-    ENDIF 
+!-- At the moment the evaluation is done with both emiss_lod and mode_emis
+!-- but once salsa has been migrated to emiss_lod the .OR. mode_emis
+!-- conditions can be removed (ecc 20190513)
+    IF     ( (emiss_lod == 1) .OR. (mode_emis == 'DEFAULT') )        THEN
+        WRITE ( io, 5 )
+    ELSEIF ( (emiss_lod == 0) .OR. (mode_emis == 'PARAMETERIZED') )  THEN 
+        WRITE ( io, 6 )
+    ELSEIF ( (emiss_lod == 2) .OR. (mode_emis == 'PRE-PROCESSED') )  THEN 
+        WRITE ( io, 7 )
+    ENDIF
 !
 !-- Photolysis scheme info
@@ -2209,5 +2221,6 @@
          decycle_method,                   &
          deposition_dry,                   &
-         emissions_anthropogenic,          &  
+         emissions_anthropogenic,          &
+         emiss_lod,                        &
          emiss_factor_main,                &
          emiss_factor_side,                &                      
@@ -2271,7 +2284,67 @@
 !
 !--    check for emission mode for chem species
-    IF ( (mode_emis /= 'PARAMETERIZED')  .AND. ( mode_emis /= 'DEFAULT' ) .AND. ( mode_emis /= 'PRE-PROCESSED'  ) )  THEN
-       message_string = 'Incorrect mode_emiss  option select. Please check spelling'
-       CALL message( 'chem_check_parameters', 'CM0436', 1, 2, 0, 6, 0 )
+
+    IF ( emiss_lod < 0 )  THEN   !- if LOD not defined in namelist
+       IF ( ( mode_emis /= 'PARAMETERIZED'  )    .AND.      &
+            ( mode_emis /= 'DEFAULT'        )    .AND.      &
+            ( mode_emis /= 'PRE-PROCESSED'  ) )  THEN
+          message_string = 'Incorrect mode_emiss  option select. Please check spelling'
+          CALL message( 'chem_check_parameters', 'CM0436', 1, 2, 0, 6, 0 )
+       ENDIF
+    ELSE
+       IF ( ( emiss_lod /= 0 )    .AND.         &
+            ( emiss_lod /= 1 )    .AND.         &
+            ( emiss_lod /= 2 ) )  THEN
+          message_string = 'Invalid value for emiss_lod (0, 1, or 2)'
+          CALL message( 'chem_check_parameters', 'CM0436', 1, 2, 0, 6, 0 )
+       ENDIF
+    ENDIF
+
+! for reference (ecc)
+!    IF ( (mode_emis /= 'PARAMETERIZED')  .AND. ( mode_emis /= 'DEFAULT' ) .AND. ( mode_emis /= 'PRE-PROCESSED'  ) )  THEN
+!       message_string = 'Incorrect mode_emiss  option select. Please check spelling'
+!       CALL message( 'chem_check_parameters', 'CM0436', 1, 2, 0, 6, 0 )
+!    ENDIF
+
+!
+!-- conflict resolution for emiss_lod and mode_emis
+!-- 1) if emiss_lod is defined, have mode_emis assume same setting as emiss_lod
+!-- 2) if emiss_lod it not defined, have emiss_lod assuem same setting as mode_emis
+!-- this check is in place to retain backward compatibility with salsa until the
+!-- code is migrated completed to emiss_lod
+    IF  ( emiss_lod >= 0 ) THEN
+       SELECT CASE  ( emiss_lod )
+          CASE (0)  !- parameterized mode
+             mode_emis = 'PARAMETERIZED'
+          CASE (1)  !- default mode
+             mode_emis = 'DEFAULT'
+          CASE (2)  !- preprocessed mode
+             mode_emis = 'PRE-PROCESSED'
+       END SELECT
+       
+       message_string = 'Synchronizing mode_emis to defined emiss_lod'               //  &
+                        CHAR(10)  //  '          '                                   //  &
+                        'NOTE - mode_emis will be depreciated in future releases'    //  &
+                        CHAR(10)  //  '          '                                   //  &
+                        'please use emiss_lod to define emission mode'
+
+       CALL message ( 'parin_chem', 'CM0463', 0, 0, 0, 6, 0 )
+    ELSE  ! if emiss_lod is not set
+       SELECT CASE ( mode_emis )
+          CASE ('PARAMETERIZED')
+             emiss_lod = 0
+          CASE ('DEFAULT')
+             emiss_lod = 1
+          CASE ('PRE-PROCESSED')
+             emiss_lod = 2
+       END SELECT
+
+       message_string = 'emiss_lod undefined.  Using existing mod_emiss setting'     //  &
+                        CHAR(10)  //  '          '                                   //  &
+                        'NOTE - mode_emis will be depreciated in future releases'    //  &
+                        CHAR(10)  //  '          '                                   //  &
+                        '       please use emiss_lod to define emission mode'
+
+       CALL message ( 'parin_chem', 'CM0464', 0, 0, 0, 6, 0 )
     ENDIF
 
